<script setup lang="ts">
import AdminFileItem from '@/components/AdminFileItem.vue'
import { client, type User, type Report } from '@/scripts/api-helper'
import { GlobalError, useAppStore } from '@/stores/app'
import { onMounted, onUnmounted, reactive } from 'vue'

const app = useAppStore()
const state = reactive({
  rows: [] as { user: User; str: string }[],
  filteredRows: [] as User[],
  search: '',
  readyCounter: 0 as number,
  validCounter: 0 as number,
  reportsByUser: {} as { [id: string]: Report[] },
  filterRejectedOnly: false,
  filterPPError: false,
  filterPPEmpty: false
})

async function loadUsers() {
  loadReports()
  const { error, data: users } = await client.GET('/api/admin/users', {
    params: {
      query: {
        admin_key: app.adminKey!
      }
    }
  })
  if (error != null) {
    app.setGlobalError(GlobalError.ActionFailedError)
  } else {
    state.rows = users.map((u) => ({
      user: u,
      str: `${u.sciper}${u.preferred_program}${u.preferred_firstname}${u.preferred_lastname}`.toLowerCase()
    }))
    updateSearch()
  }
}

function updateSearch() {
  if (state.search.length > 0) {
    const q = state.search.toLowerCase()
    state.filteredRows = state.rows
      .filter(
        (u) =>
          u.str.includes(q) &&
          (!state.filterRejectedOnly || u.user.rejected) &&
          (!state.filterPPEmpty || u.user.profile_picture_status === 'Empty') &&
          (!state.filterPPError ||
            u.user.profile_picture_status === 'Error' ||
            u.user.profile_picture_status === 'ProcessingFrame' ||
            u.user.profile_picture_status === 'ProcessingRembg')
      )
      .map((u) => u.user)
  } else {
    state.filteredRows = state.rows
      .filter(
        (u) =>
          (!state.filterRejectedOnly || u.user.rejected) &&
          (!state.filterPPEmpty || u.user.profile_picture_status === 'Empty') &&
          (!state.filterPPError ||
            u.user.profile_picture_status === 'Error' ||
            u.user.profile_picture_status === 'ProcessingFrame' ||
            u.user.profile_picture_status === 'ProcessingRembg')
      )
      .map((u) => u.user)
  }
  let readyCounter = 0
  let validCounter = 0
  state.filteredRows.forEach((u) => {
    if (u.profile_picture_status === 'Ready') {
      readyCounter++
    }
    if (u.form_validated) {
      validCounter++
    }
  })
  state.readyCounter = readyCounter
  state.validCounter = validCounter
}

async function loadReports() {
  const { error, data: reports } = await client.GET('/api/admin/reports', {
    params: {
      query: {
        admin_key: app.adminKey!
      }
    }
  })
  if (error != null) {
    app.setGlobalError(GlobalError.ActionFailedError)
  } else {
    state.reportsByUser = {}
    let reportsByUser: { [id: string]: Report[] } = {}
    for (let r of reports) {
      if (r.user_id != null) {
        let reports = reportsByUser[r.user_id]
        if (reports != null) {
          reportsByUser[r.user_id].push(r)
        } else {
          reportsByUser[r.user_id] = [r]
        }
      }
    }
    state.reportsByUser = reportsByUser
  }
}

async function reject(user: User) {
  const { error } = await client.POST('/api/admin/user/{sciper}/rejected', {
    params: {
      path: {
        sciper: user.sciper
      }
    },
    body: {
      admin_key: app.adminKey!,
      rejected: !user.rejected
    }
  })
  if (error != null) {
    app.setGlobalError(GlobalError.ActionFailedError)
  } else {
    loadUsers()
  }
}

let intervalId = -1
onMounted(() => {
  loadUsers()
  intervalId = setInterval(updateSearch, 1000)
})

onUnmounted(() => {
  clearInterval(intervalId)
})
</script>

<template>
  <main id="main">
    <div class="mb-3 flex space-x-3 items-center">
      <h1 class="grow mb-3 text-2xl dark:text-white font-semibold">Files</h1>
      <div class="flex items-center">
        <input
          id="checkbox-pp-error"
          type="checkbox"
          v-model="state.filterPPError"
          class="w-4 h-4 text-blue-600 bg-gray-100 border-gray-300 rounded focus:ring-blue-500 dark:focus:ring-blue-600 dark:ring-offset-gray-800 focus:ring-2 dark:bg-gray-700 dark:border-gray-600"
        />
        <label
          for="checkbox-pp-error"
          class="ms-2 text-sm font-medium text-gray-400 dark:text-gray-500"
          >PP error</label
        >
      </div>
      <div class="flex items-center">
        <input
          id="checkbox-pp-empty"
          type="checkbox"
          v-model="state.filterPPEmpty"
          class="w-4 h-4 text-blue-600 bg-gray-100 border-gray-300 rounded focus:ring-blue-500 dark:focus:ring-blue-600 dark:ring-offset-gray-800 focus:ring-2 dark:bg-gray-700 dark:border-gray-600"
        />
        <label
          for="checkbox-pp-empty"
          class="ms-2 text-sm font-medium text-gray-400 dark:text-gray-500"
          >PP empty</label
        >
      </div>
      <div class="flex items-center">
        <input
          id="checkbox-rejected"
          type="checkbox"
          v-model="state.filterRejectedOnly"
          class="w-4 h-4 text-blue-600 bg-gray-100 border-gray-300 rounded focus:ring-blue-500 dark:focus:ring-blue-600 dark:ring-offset-gray-800 focus:ring-2 dark:bg-gray-700 dark:border-gray-600"
        />
        <label
          for="checkbox-rejected"
          class="ms-2 text-sm font-medium text-gray-400 dark:text-gray-500"
          >Rejected</label
        >
      </div>
      <input
        v-model="state.search"
        id="password"
        class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full max-w-80 p-2.5 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
        placeholder="Search"
      />
      <AppButton @click="loadUsers">Reload</AppButton>
    </div>

    <section class="bg-gray-50 antialiased dark:bg-gray-900">
      <div class="mx-auto max-w-screen-xl px-4 2xl:px-0">
        <div class="mb-4 grid gap-4 grid-cols-2 sm:grid-cols-3 md:grid-cols-4 md:mb-8">
          <AdminFileItem
            v-for="user of state.filteredRows"
            v-bind:key="user.sciper"
            :user="user"
            :reports="state.reportsByUser[user.sciper] ?? []"
            @reject="() => reject(user)"
          />
        </div>
      </div>
    </section>
  </main>
</template>
